﻿using DataEntity;
using Sklad.ViewModels;
using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Sklad.Presentation
{
    /// <summary>
    /// Interaction logic for pgPrehMat.xaml
    /// </summary>
    public partial class pgPrehMat : Page
    {
        private pgPrehMatVM _datacontext;

        public pgPrehMat()
        {

            InitializeComponent();
            _datacontext = new pgPrehMatVM();
            this.DataContext = _datacontext;

        }

        private void btnEditMat_Click(object sender, RoutedEventArgs e)
        {
            _datacontext.AktualniRezim = pgPrehMatVM.Rezimy.Editace;
        }

        private void PotvrditCanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
            e.CanExecute = Globals.IsValid(gbLeva) && Globals._context.ChangeTracker.HasChanges();
        }


        private void btnOK_Click(object sender, RoutedEventArgs e)
        {
            Globals.UlozitData();
            _datacontext.AktualniRezim = pgPrehMatVM.Rezimy.Prohlizeni;
        }

        private SkladContext _context = Globals._context;

        private void btnAddMat_Click(object sender, RoutedEventArgs e)
        {
            //nová instance materiálu
            Material material = new Material();

            //výchozí datum je dnešní
            material.Datum = DateTime.Today;

            //přidat tuto instaci do kontextu (databáze) - nepovinné
            _context.Materialy.Add(material);

            //přidat ji i do kolekce
            _datacontext.MaterialyCol.Add(material);

            //nový materiál je vybraným materiálem
            _datacontext.MaterialSelected = material;
            //nastavení režimu
            _datacontext.AktualniRezim = pgPrehMatVM.Rezimy.Pridavani;
            //fokus komponenty na vybraný materiál
            dgMaterialy.ScrollIntoView(_datacontext.MaterialSelected);

        }

        private void btnStrono_Click(object sender, RoutedEventArgs e)
        {
            if (_datacontext.AktualniRezim == pgPrehMatVM.Rezimy.Pridavani)
            {
                _context.Entry(_datacontext.MaterialSelected).State = EntityState.Detached;
                _datacontext.MaterialyCol.Remove(_datacontext.MaterialSelected);
                _datacontext.MaterialSelected = null;
            }

            if (_datacontext.AktualniRezim == pgPrehMatVM.Rezimy.Editace)
            {
                Globals.RollBack();
            }


            _datacontext.AktualniRezim = pgPrehMatVM.Rezimy.Prohlizeni;

        }

        private void btnDelMat_Click(object sender, RoutedEventArgs e)
        {
            if (_datacontext.MaterialSelected.Palety.Count>0)
            {
                MessageBox.Show("Nelze smazat. Materiál je obsažen v paletách", "CHYBA",
                    MessageBoxButton.OK, MessageBoxImage.Warning);
                return;
            }
            
           var res = MessageBox.Show("Opravdu chcete smazat materiál " + _datacontext.MaterialSelected.NazevMat,
                   "VAROVÁNÍ",
                    MessageBoxButton.YesNo, MessageBoxImage.Warning);
            if (res == MessageBoxResult.No) return;

            _context.Materialy.Remove(_datacontext.MaterialSelected);

            _datacontext.MaterialyCol.Remove(_datacontext.MaterialSelected);

     
            // _context.Entry(_datacontext.MaterialSelected).State = EntityState.Deleted;

            _datacontext.MaterialSelected = null;

            Globals.UlozitData();

        }
    }
}
